// Code generated by protoc-gen-go. DO NOT EDIT.
// source: apex/configure.proto

package apex

import (
	context "context"
	fmt "fmt"
	proto "github.com/golang/protobuf/proto"
	grpc "google.golang.org/grpc"
	math "math"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion3 // please upgrade the proto package

func init() { proto.RegisterFile("apex/configure.proto", fileDescriptor_6a02804ae9134473) }

var fileDescriptor_6a02804ae9134473 = []byte{
	// 183 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xe2, 0x12, 0x49, 0x2c, 0x48, 0xad,
	0xd0, 0x4f, 0xce, 0xcf, 0x4b, 0xcb, 0x4c, 0x2f, 0x2d, 0x4a, 0xd5, 0x2b, 0x28, 0xca, 0x2f, 0xc9,
	0x17, 0x62, 0x01, 0x89, 0x4a, 0xf1, 0x43, 0xe5, 0x60, 0xc2, 0x46, 0x53, 0x99, 0xb9, 0x04, 0x9d,
	0x61, 0x4a, 0x5d, 0xf3, 0x52, 0x0a, 0xf2, 0x33, 0xf3, 0x4a, 0x84, 0x1c, 0xb8, 0x58, 0x7c, 0x32,
	0x8b, 0x4b, 0x84, 0xa4, 0xf4, 0x40, 0xea, 0xf5, 0x60, 0x0a, 0x12, 0x4b, 0x32, 0xf3, 0xf3, 0x82,
	0x52, 0x0b, 0x4b, 0x53, 0x8b, 0x4b, 0xa4, 0x64, 0xb0, 0xc8, 0x15, 0x07, 0xa5, 0x16, 0x17, 0xe4,
	0xe7, 0x15, 0xa7, 0x0a, 0x99, 0x70, 0xb1, 0x83, 0x4c, 0x70, 0xcc, 0xc9, 0x11, 0xe2, 0x86, 0x28,
	0x74, 0xcd, 0x2d, 0x28, 0xa9, 0x24, 0xa0, 0xcb, 0x91, 0x8b, 0xcd, 0xb9, 0x28, 0x35, 0xb1, 0x24,
	0x15, 0xaf, 0xcd, 0xd2, 0x58, 0xe5, 0xa0, 0x46, 0xd8, 0x73, 0xb1, 0x04, 0xa5, 0x26, 0xa6, 0x90,
	0x6f, 0x80, 0x23, 0x17, 0x5b, 0x68, 0x41, 0x0a, 0x45, 0x6e, 0x70, 0xe4, 0x62, 0x73, 0x49, 0xcd,
	0x49, 0xa5, 0xc0, 0x88, 0x24, 0x36, 0x70, 0xf4, 0x18, 0x03, 0x02, 0x00, 0x00, 0xff, 0xff, 0x27,
	0x06, 0x67, 0xfd, 0xcd, 0x01, 0x00, 0x00,
}

// Reference imports to suppress errors if they are not otherwise used.
var _ context.Context
var _ grpc.ClientConn

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
const _ = grpc.SupportPackageIsVersion4

// ConfigureEndpointClient is the client API for ConfigureEndpoint service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://godoc.org/google.golang.org/grpc#ClientConn.NewStream.
type ConfigureEndpointClient interface {
	// List all configurations for a single namespace
	List(ctx context.Context, in *ConfigurationRequest, opts ...grpc.CallOption) (*ConfigurationsResponse, error)
	// List all configurations
	ListAll(ctx context.Context, in *Empty, opts ...grpc.CallOption) (*ConfigurationsResponse, error)
	Create(ctx context.Context, in *ConfigurationRequest, opts ...grpc.CallOption) (*ConfigurationResponse, error)
	Read(ctx context.Context, in *ConfigurationRequest, opts ...grpc.CallOption) (*ConfigurationResponse, error)
	Update(ctx context.Context, in *ConfigurationRequest, opts ...grpc.CallOption) (*ConfigurationResponse, error)
	Delete(ctx context.Context, in *ConfigurationRequest, opts ...grpc.CallOption) (*ConfigurationResponse, error)
}

type configureEndpointClient struct {
	cc *grpc.ClientConn
}

func NewConfigureEndpointClient(cc *grpc.ClientConn) ConfigureEndpointClient {
	return &configureEndpointClient{cc}
}

func (c *configureEndpointClient) List(ctx context.Context, in *ConfigurationRequest, opts ...grpc.CallOption) (*ConfigurationsResponse, error) {
	out := new(ConfigurationsResponse)
	err := c.cc.Invoke(ctx, "/apex.ConfigureEndpoint/List", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *configureEndpointClient) ListAll(ctx context.Context, in *Empty, opts ...grpc.CallOption) (*ConfigurationsResponse, error) {
	out := new(ConfigurationsResponse)
	err := c.cc.Invoke(ctx, "/apex.ConfigureEndpoint/ListAll", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *configureEndpointClient) Create(ctx context.Context, in *ConfigurationRequest, opts ...grpc.CallOption) (*ConfigurationResponse, error) {
	out := new(ConfigurationResponse)
	err := c.cc.Invoke(ctx, "/apex.ConfigureEndpoint/Create", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *configureEndpointClient) Read(ctx context.Context, in *ConfigurationRequest, opts ...grpc.CallOption) (*ConfigurationResponse, error) {
	out := new(ConfigurationResponse)
	err := c.cc.Invoke(ctx, "/apex.ConfigureEndpoint/Read", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *configureEndpointClient) Update(ctx context.Context, in *ConfigurationRequest, opts ...grpc.CallOption) (*ConfigurationResponse, error) {
	out := new(ConfigurationResponse)
	err := c.cc.Invoke(ctx, "/apex.ConfigureEndpoint/Update", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *configureEndpointClient) Delete(ctx context.Context, in *ConfigurationRequest, opts ...grpc.CallOption) (*ConfigurationResponse, error) {
	out := new(ConfigurationResponse)
	err := c.cc.Invoke(ctx, "/apex.ConfigureEndpoint/Delete", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// ConfigureEndpointServer is the server API for ConfigureEndpoint service.
type ConfigureEndpointServer interface {
	// List all configurations for a single namespace
	List(context.Context, *ConfigurationRequest) (*ConfigurationsResponse, error)
	// List all configurations
	ListAll(context.Context, *Empty) (*ConfigurationsResponse, error)
	Create(context.Context, *ConfigurationRequest) (*ConfigurationResponse, error)
	Read(context.Context, *ConfigurationRequest) (*ConfigurationResponse, error)
	Update(context.Context, *ConfigurationRequest) (*ConfigurationResponse, error)
	Delete(context.Context, *ConfigurationRequest) (*ConfigurationResponse, error)
}

func RegisterConfigureEndpointServer(s *grpc.Server, srv ConfigureEndpointServer) {
	s.RegisterService(&_ConfigureEndpoint_serviceDesc, srv)
}

func _ConfigureEndpoint_List_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ConfigurationRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ConfigureEndpointServer).List(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/apex.ConfigureEndpoint/List",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ConfigureEndpointServer).List(ctx, req.(*ConfigurationRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _ConfigureEndpoint_ListAll_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Empty)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ConfigureEndpointServer).ListAll(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/apex.ConfigureEndpoint/ListAll",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ConfigureEndpointServer).ListAll(ctx, req.(*Empty))
	}
	return interceptor(ctx, in, info, handler)
}

func _ConfigureEndpoint_Create_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ConfigurationRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ConfigureEndpointServer).Create(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/apex.ConfigureEndpoint/Create",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ConfigureEndpointServer).Create(ctx, req.(*ConfigurationRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _ConfigureEndpoint_Read_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ConfigurationRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ConfigureEndpointServer).Read(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/apex.ConfigureEndpoint/Read",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ConfigureEndpointServer).Read(ctx, req.(*ConfigurationRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _ConfigureEndpoint_Update_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ConfigurationRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ConfigureEndpointServer).Update(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/apex.ConfigureEndpoint/Update",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ConfigureEndpointServer).Update(ctx, req.(*ConfigurationRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _ConfigureEndpoint_Delete_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ConfigurationRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ConfigureEndpointServer).Delete(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/apex.ConfigureEndpoint/Delete",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ConfigureEndpointServer).Delete(ctx, req.(*ConfigurationRequest))
	}
	return interceptor(ctx, in, info, handler)
}

var _ConfigureEndpoint_serviceDesc = grpc.ServiceDesc{
	ServiceName: "apex.ConfigureEndpoint",
	HandlerType: (*ConfigureEndpointServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "List",
			Handler:    _ConfigureEndpoint_List_Handler,
		},
		{
			MethodName: "ListAll",
			Handler:    _ConfigureEndpoint_ListAll_Handler,
		},
		{
			MethodName: "Create",
			Handler:    _ConfigureEndpoint_Create_Handler,
		},
		{
			MethodName: "Read",
			Handler:    _ConfigureEndpoint_Read_Handler,
		},
		{
			MethodName: "Update",
			Handler:    _ConfigureEndpoint_Update_Handler,
		},
		{
			MethodName: "Delete",
			Handler:    _ConfigureEndpoint_Delete_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "apex/configure.proto",
}
